define(function(require,exports){var a=require("configs/settings"),b=require("configs/dict"),c=require("utils/calculate"),d=require("utils/hash"),e=require("utils/string"),f=require("utils/timeformat"),g=require("utils/log"),h=require("service/prefs"),i=require("utils/server"),j=(require("utils/dbstore"),require("utils/task-util")),k=require("utils/index");exports.Model=Backbone.Model.extend({defaults:{title:"",content:"",sortOrder:0,priority:0,projectId:a.user.inboxId,dueDate:null,timeZone:h.get("timeZone"),status:0,items:[]},validate:function(a){return a.id?void 0:"need error"},messages:function(){this.on("change",this.taskItemChange),this.on("toggleModelComplete",this.toggleModelComplete,this),this.on("deleteForever",this.deleteForever,this),this.on("restore",this.restore,this),this.on("dropOnOverdueTaskGroup",this.dropOnOverdueTaskGroup,this),this.on("dropOnTodayTaskGroup",this.dropOnTodayTaskGroup,this),this.on("dropOnTomorrowTaskGroup",this.dropOnTomorrowTaskGroup,this),this.on("dropOnDayTaskGroup",this.dropOnDayTaskGroup,this),this.on("dropOnNext7DaysTaskGroup",this.dropOnNext7DaysTaskGroup,this),this.on("dropOnLaterTaskGroup",this.dropOnLaterTaskGroup,this),this.on("dropOnNoDateTaskGroup",this.dropOnNoDateTaskGroup,this),this.on("dropOnUrgentPriorityTaskGroup",this.dropOnUrgentPriorityTaskGroup,this),this.on("dropOnNormalPriorityTaskGroup",this.dropOnNormalPriorityTaskGroup,this),this.on("dropOnLowPriorityTaskGroup",this.dropOnLowPriorityTaskGroup,this),this.on("dropOnNoPriorityTaskGroup",this.dropOnNoPriorityTaskGroup,this),this.on("dropOnCompletedTaskGroup",this.dropOnCompletedTaskGroup,this),this.on("dropOnCompletedTaskGroupInCompleted",this.dropOnCompletedTaskGroupInCompleted,this),this.on("dropOnSortOrderTaskGroup",this.dropOnSortOrderTaskGroup,this),this.on("dropOnAssignmentTaskGroup",this.dropOnAssignmentTaskGroup,this),this.on("change:dueDate",this.updateRemindTime),this.on("sync",this.afterSync)},initialize:function(){this.changedTime=f.prefMoment().unix(),this.messages(),this.dumpInTemp(this)},detectMetionedDatetime:function(){if(a.autoParseDate&&_.isEmpty(this.get("dueDate"))){var b=chrono.parseDate(this.get("title"));null!=b&&(this.set("dueDate",f.prefMoment(b).format("YYYY-MM-DDTHH:mm:00.000ZZ")),"0000"!=f.prefMoment(b).format("HHmm")&&this.set("reminder",a.reminderStamp),this.trigger("rerenderDueDateForRepeatToRepeat"))}},resetModifyData:function(){this.set("modifiedItems",{deletedIds:[],modifiedIds:[]})},updateModifiedIds:function(a){var b=this.get("modifiedItems");null==b&&this.resetModifyData(),-1===_.indexOf(this.get("modifiedItems").modifiedIds,a)&&this.get("modifiedItems").modifiedIds.push(a)},updateDeletedIds:function(a){var b=this.get("modifiedItems");null==b&&this.resetModifyData(),-1===_.indexOf(this.get("modifiedItems").deletedIds,a)&&this.get("modifiedItems").deletedIds.push(a)},checkItemsOrder:function(){var a=_.sortBy(this.get("items"),function(a){return a.sortOrder});return a=_.sortBy(a,function(a){return a.status}),this.set({items:a},{silent:!0}),a},updateItemsOrder:function(){if(this.get("items").length>0){var a=0,b=this;_.each(this.get("items"),function(c){c.sortOrder!=a&&(b.updateModifiedIds(c.id),c.sortOrder=a),a+=1})}},taskItemChange:function(){f.prefMoment().format(b.format.atomTime)},unmarkDirty:function(){this.isDirty=!1},markDirty:function(){this.isDirty=!0,Backbone.trigger("dumpInOriginalServer",this)},url:function(){return a.API_HOST+"/task"+(this.isNew()?"":"/"+this.id)},updateRemindTime:function(){var a=c.remindTime(this.get("dueDate"),this.get("reminder"));this.set("remindTime",a)},_cloneAchiveTask:function(){var a=k.objClone(this);a.set("id",ObjectId()),a.set("repeatFlag",null),a.set("etag",null),a.set("status",2),a.set("completedTime",f.prefMoment().format(b.format.atomTime)),a.local=!0,a.save()},toggleModelComplete:function(c){var d=this.get("status"),e=d?0:a.autoArchive?2:1;e>0?this.set({completedTime:f.prefMoment().format(b.format.atomTime)}):(this.unset("completedTime"),this.set({sortOrder:c?c:this.get("sortOrder")}));var g=this.isWillRepeat=this.willRepeat();g?(this.set("status",0),this._cloneAchiveTask(),this.set("dueDate",this.nextDueDate),this.trigger("toggleRepeatTip"),Backbone.trigger("moveTaskGroup",[this])):this.set("status",e),this.updateItemsOrder(),this.save(),g&&this.unset("completedTime"),a.autoArchive&&2===e&&(this.trigger("transferToCompleted"),Backbone.trigger("closeDetailView"))},afterSync:function(){this.local=null,this.set("local",!1),Backbone.trigger("refreshTagsList");var a=_.sortBy(this.get("items"),function(a){return a.sortOrder});this.set({items:a},{silent:!0}),this.resetModifyData(),d.isInCompleted()&&0===this.get("status")&&(this.trigger("destroy"),this.trigger("closeDetailView")),Backbone.trigger("rerenderActionBar"),Backbone.trigger("updateCalendarDatesWithTask"),this.unmarkDirty(),this.requesting=!1,this.saveCallback&&this.save()},dropOnOverdueTaskGroup:function(){var a=this.getTimeByDueDate(this.get("dueDate"));this.save({status:0,dueDate:f.prefMoment().subtract("days",1).format("YYYY-MM-DDT"+a+".000ZZ")})},dropOnTodayTaskGroup:function(){var a=this.getTimeByDueDate(this.get("dueDate")),b=f.prefMoment().format("YYYY-MM-DDT"+a+".000ZZ");this.save({status:0,dueDate:b,repeatFirstDate:b})},dropOnTomorrowTaskGroup:function(){var a=this.getTimeByDueDate(this.get("dueDate")),b=f.prefMoment().add("days",1).format("YYYY-MM-DDT"+a+".000ZZ");this.save({status:0,dueDate:b,repeatFirstDate:b})},dropOnDayTaskGroup:function(a){var b=this.getTimeByDueDate(this.get("dueDate")),c=f.prefMoment().add("days",a).format("YYYY-MM-DDT"+b+".000ZZ");this.save({status:0,dueDate:c,repeatFirstDate:c})},dropOnNext7DaysTaskGroup:function(){var a=this.getTimeByDueDate(this.get("dueDate")),b=f.prefMoment().add("days",2).format("YYYY-MM-DDT"+a+".000ZZ");this.save({status:0,dueDate:b,repeatFirstDate:b})},dropOnLaterTaskGroup:function(){var a=this.getTimeByDueDate(this.get("dueDate")),b=f.prefMoment().add("days",8).format("YYYY-MM-DDT"+a+".000ZZ");this.save({status:0,dueDate:b,repeatFirstDate:b})},dropOnNoDateTaskGroup:function(){this.save({status:0,dueDate:null})},dropOnUrgentPriorityTaskGroup:function(){this.save({status:0,priority:5})},dropOnNormalPriorityTaskGroup:function(){this.save({status:0,priority:3})},dropOnLowPriorityTaskGroup:function(){this.save({status:0,priority:1})},dropOnNoPriorityTaskGroup:function(){this.save({status:0,priority:0})},dropOnCompletedTaskGroup:function(){return this.willRepeat()?void this.toggleModelComplete():void this.save({status:a.autoArchive?2:1})},dropOnCompletedTaskGroupInCompleted:function(c){this.set({completedTime:f.prefMoment(c).format(b.format.atomTime),status:a.autoArchive?2:1}),this.save()},dropOnSortOrderTaskGroup:function(){this.save({status:0})},dropOnAssignmentTaskGroup:function(a){var a=arguments[0]?arguments[0]:null;this.save({assignee:a})},save:function(a,b){var c=(new Date).getTime(),d=this.lastSyncTime||0,e=c-d;if(this.saveCallback=!1,12e4>=e&&this.requesting)return this.saveCallback=!0,void g.log("frequent saving detected");this.lastSyncTime=c,this.requesting=!0,Backbone.trigger("dumpInOriginalClient",this);var f=this;this.updateItemsOrder();b||(b={}),b.error=function(a){g.log("task save error",a)};var h=b.success;f.unmarkDirty(),b.success=function(a,b,c){_.isFunction(h)&&h(a,b,c)},Backbone.Model.prototype.save.call(this,a,b)},deleteForever:function(){var a={taskId:this.get("id"),projectId:this.get("projectId")};i.deleteTaskForever([a])},restore:function(){var a={taskId:this.get("id"),projectId:this.get("projectId")};i.restoreTrashTask(this.get("projectId"),JSON.stringify([a]))},hasAssign:function(){return 0===parseInt(this.get("assignee"))?(this.set("assignee",-1),!1):null==this.get("assignee")||-1===parseInt(this.get("assignee"))?!1:!0},subtaskNotText:function(){return this.get("items").length>0},textNotSubtask:function(){return 0===this.get("items").length},hasContent:function(){return!_.isEmpty(this.get("content"))},willRepeat:function(){var a=this.get("repeatFlag");if(null===a||_.isEmpty(a))return!1;var b=this.nextDueDate=j.getNextDueDate(this);return b?!0:!1},getTimeByDueDate:function(a){return null!=a?f.prefMoment(a).format("HH:mm:ss"):"00:00:00"},locateSubview:function(a){var b=this,c=_.filter(a,function(a){return null!=a.taskListItemViews[b.id]});return c[0]||null},findTargetSubview:function(a){var b=this,c=_.filter(a,function(a){return a.ifCanShowIn(b)});return c[0]||null},hasReminder:function(){if(0===this.get("status")&&e.isValidReminder(this.get("reminder"))&&this.get("dueDate")){var a=f.prefMoment(this.get("dueDate")).diff(f.prefMoment().startOf("minute"),"minutes");if(a>0)return!0}return!1},formatItemDuedate:function(){var a=this.get("dueDate"),b=this.get("reminder");return h.getListItemDueDateForList(a,b)},isNormal:function(){return 0===this.get("status")},dumpInTemp:function(a){this.beforeChange=JSON.parse(JSON.stringify(a))}})});